using System;
using System.Reflection;

namespace ThinkGeo.MapSuite.Layers
{
    [Serializable]
    public struct LegendDrawingParameters
    {
        [Obfuscation(Exclude = true)]
        private float xOffset;
        [Obfuscation(Exclude = true)]
        private float yOffset;

        public float XOffset
        {
            get { return xOffset; }
            set { xOffset = value; }
        }

        public float YOffset
        {
            get { return yOffset; }
            set { yOffset = value; }
        }

        public override int GetHashCode()
        {
            return (int)(xOffset * 1000000) ^ (int)(yOffset * 1000000);
        }

        public override bool Equals(object obj)
        {
            if (obj == null)
            {
                return false;
            }
            else if (obj is LegendDrawingParameters)
            {
                return Equals((LegendDrawingParameters)obj);
            }
            else
            {
                return false;
            }
        }

        private bool Equals(LegendDrawingParameters param)
        {
            if (XOffset == param.XOffset && YOffset == param.YOffset)
            {
                return true;
            }
            return false;
        }

        public static bool operator ==(LegendDrawingParameters param1, LegendDrawingParameters param2)
        {
            return param1.Equals(param2);
        }

        public static bool operator !=(LegendDrawingParameters param1, LegendDrawingParameters param2)
        {
            return !(param1 == param2);
        }
    }
}
